Maximum override line length is too short

Bug #1038961 reported by Colin Watson on 2012-08-20
14
This bug affects 2 people
Affects Status Importance Assigned to Milestone
apt (Ubuntu)
High
Colin Watson
Lucid
High
Colin Watson
Precise
High
Colin Watson

Bug Description

[Impact] The Launchpad publisher is producing malformed Task lines in Packages files, which has the potential to cause image builds to be incomplete.
[Test Case] Grab the extra-override input files from the primary archive and try to run apt-ftparchive using them (perhaps cut down to include just the longest lines). It should avoid emitting "Malformed override" messages and should produce non-truncated Task lines in Packages files.
[Regression Potential] Barring toolchain bugs, any regressions should be confined to apt-ftparchive. (But this change is very simple, so I'm not especially worried.)

We see quite a few messages like this from the publisher:

  W: Malformed override /srv/launchpad.net/ubuntu-archive/ubuntu-overrides/override.quantal.extra.main line 14628 #2

These correspond to override lines that are too long. This example is:

  libmng1/powerpc Task ubuntu-desktop, ubuntu-usb, kubuntu-desktop, kubuntu-active-desktop, kubuntu-active, edubuntu-desktop, edubuntu-desktop-kde, edubuntu-usb, xubuntu-desktop, mythbuntu-frontend, mythbuntu-frontend, mythbuntu-desktop, mythbuntu-backend-slave, mythbuntu-backend-slave, mythbuntu-backend-master, mythbuntu-backend-master, ubuntustudio-generation, ubuntustudio-video, ubuntustudio-audio-plugins, ubuntustudio-publishing, ubuntustudio-photography, ubuntustudio-graphics, ubuntustudio-recording

This carries over into truncated Task fields in Packages files.

Override::ReadOverride currently has "char Line[500]", which is the cause of this. Ideally, this code would handle arbitrary-length lines. However, in practice, the maximum line length we're seeing in quantal is 594, so simply doubling this to 1000 would do nicely for now.

Colin Watson (cjwatson) wrote :

We'll want to fix this in lucid (current publisher host system) and precise (future publisher host system).

Changed in apt (Ubuntu):
status: New → Triaged
importance: Undecided → High
Changed in apt (Ubuntu Lucid):
status: New → Triaged
importance: Undecided → High
Changed in apt (Ubuntu Precise):
status: New → Triaged
importance: Undecided → High
milestone: none → ubuntu-12.04.2
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package apt - 0.9.7.1ubuntu2

---------------
apt (0.9.7.1ubuntu2) quantal; urgency=low

  * ftparchive/override.cc:
    - Double maximum override line length to 1000 (LP: #1038961).
 -- Colin Watson <email address hidden> Mon, 20 Aug 2012 12:04:30 +0100

Changed in apt (Ubuntu):
status: Triaged → Fix Released
Colin Watson (cjwatson) on 2012-08-20
Changed in apt (Ubuntu):
assignee: nobody → Colin Watson (cjwatson)
Changed in apt (Ubuntu Lucid):
assignee: nobody → Colin Watson (cjwatson)
Changed in apt (Ubuntu Precise):
assignee: nobody → Colin Watson (cjwatson)
Colin Watson (cjwatson) on 2012-08-20
description: updated
Changed in apt (Ubuntu Lucid):
status: Triaged → In Progress
Changed in apt (Ubuntu Precise):
status: Triaged → In Progress

Hello Colin, or anyone else affected,

Accepted apt into precise-proposed. The package will build now and be available at http://launchpad.net/ubuntu/+source/apt/0.8.16~exp12ubuntu10.3 in a few hours, and then in the -proposed repository.

Please help us by testing this new package. See https://wiki.ubuntu.com/Testing/EnableProposed for documentation how to enable and use -proposed. Your feedback will aid us getting this update out to other Ubuntu users.

If this package fixes the bug for you, please change the bug tag from verification-needed to verification-done. If it does not, change the tag to verification-failed. In either case, details of your testing will help us make a better decision.

Further information regarding the verification process can be found at https://wiki.ubuntu.com/QATeam/PerformingSRUVerification . Thank you in advance!

Changed in apt (Ubuntu Precise):
status: In Progress → Fix Committed
tags: added: verification-needed
Changed in apt (Ubuntu Lucid):
status: In Progress → Fix Committed
Adam Conrad (adconrad) wrote :

Hello Colin, or anyone else affected,

Accepted apt into lucid-proposed. The package will build now and be available at http://launchpad.net/ubuntu/+source/apt/0.7.25.3ubuntu9.14 in a few hours, and then in the -proposed repository.

Please help us by testing this new package. See https://wiki.ubuntu.com/Testing/EnableProposed for documentation how to enable and use -proposed. Your feedback will aid us getting this update out to other Ubuntu users.

If this package fixes the bug for you, please change the bug tag from verification-needed to verification-done. If it does not, change the tag to verification-failed. In either case, details of your testing will help us make a better decision.

Further information regarding the verification process can be found at https://wiki.ubuntu.com/QATeam/PerformingSRUVerification . Thank you in advance!

Colin Watson (cjwatson) on 2012-09-25
tags: added: verification-ok
removed: verification-needed
tags: added: verification-done
removed: verification-ok

The verification of this Stable Release Update has completed successfully and the package has now been released to -updates. Subsequently, the Ubuntu Stable Release Updates Team is being unsubscribed and will not receive messages about this bug report. In the event that you encounter a regression using the package from -updates please report a new bug using ubuntu-bug and tag the bug report regression-update so we can easily find any regresssions.

Launchpad Janitor (janitor) wrote :

This bug was fixed in the package apt - 0.7.25.3ubuntu9.14

---------------
apt (0.7.25.3ubuntu9.14) lucid-proposed; urgency=low

  * ftparchive/override.cc:
    - Double maximum override line length to 1000 (LP: #1038961).
 -- Colin Watson <email address hidden> Mon, 20 Aug 2012 13:40:41 +0100

Changed in apt (Ubuntu Lucid):
status: Fix Committed → Fix Released
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package apt - 0.8.16~exp12ubuntu10.3

---------------
apt (0.8.16~exp12ubuntu10.3) precise-proposed; urgency=low

  * ftparchive/override.cc:
    - Double maximum override line length to 1000 (LP: #1038961).
 -- Colin Watson <email address hidden> Mon, 20 Aug 2012 13:47:32 +0100

Changed in apt (Ubuntu Precise):
status: Fix Committed → Fix Released
To post a comment you must log in.
This report contains Public information  Edit
Everyone can see this information.

Other bug subscribers